format PE GUI 4.0
entry start

include '..\win32a.inc'


; struct  ICONDIR
;   iReserved   dw ?
;   iResourceType  dw ?
;   iImageCount dw ?
;   ICONDIRENTRY
; ends


struct ICONDIRENTRY   ;   ICONDIR    .ico 
  bWidth db ?;          // Width, in pixels, of the image
  bHeight  rb 1;        // Height, in pixels, of the image
  bColorCount rb 1;     // Number of colors in image (0 if >=8bpp)
  bReserved rb 1;       // Reserved ( must be 0)
  wPlanes dw ?;         // Color Planes
  wBitCount dw ?;       // Bits per pixel
  dwBytesInRes dd ?;    // How many bytes in this resource?
  dwImageOffset dd ?;   // Where in the file is this image?
ends


struct ICONDIRGROUPICON 	;  Group Icon
       Reserved1       dw   ?	  ;0
       ResourceType    dw   ?	  ;  1-;2-
       ImageCount      dw   ?	 ; 
       _Width	       rb 1   ;
       _Height	       rb 1   ;
       Colors	       rb 1   ;
       Reserved2       rb 1   ;0
       Planes	       dw   ?
       BitsPerPixel    dw   ?
       ImageSize       dd   ?  ;  
       ResourceID      dw   ?  ; 
ends



section '.code' code readable writeable executable

  start:
   ;\\\\\\\\\\\\\\\\\\\\\\    
     invoke CreateFile,icBuf,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
     cmp eax,-1
     je error
     mov [fIconh],eax
     invoke GetFileSize,[fIconh],szIcl
     mov  [szIc],eax
     invoke LocalAlloc,LMEM_FIXED+LMEM_ZEROINIT,eax
     mov [ficon],eax
     invoke ReadFile,[fIconh],[ficon],[szIc],cread,NULL
     invoke CloseHandle,[fIconh]

  ;\\\\\\\\   ICONDIRENTRY
     xor ebx,ebx
     mov eax,[ficon]
     add eax,6		 ;  6   ICONDIR
     mov bl,byte[eax]
     mov [icdir.bWidth],bl   ;
     inc eax
     mov bl,byte[eax]
     mov [icdir.bHeight],bl    ;
     inc eax
     mov bl,byte[eax]
     mov [icdir.bColorCount],bl    ;
     inc eax
     mov bl,byte[eax]
     mov [icdir.bReserved],bl
     inc eax
     mov bx,word[eax]
     mov [icdir.wPlanes],bx
     add eax,2
     mov bx,word[eax]
     mov [icdir.wBitCount],bx
     add eax,2
     push dword[eax]
     pop [icdir.dwBytesInRes]	;  
     add eax,4
     push dword[eax]
     pop [icdir.dwImageOffset]	 ;    



 ;\\\\\\\\\\\\\\\   ICONDIRGROUPICON
     xor ebx,ebx
     mov  [icdirgr.ResourceType],1    ; 
     mov  [icdirgr.ImageCount],1	; 
     mov  bl,[icdir.bWidth]
     mov  [icdirgr._Width],bl	      ;
     mov  bl,[icdir.bHeight]
     mov  [icdirgr._Height],bl	      ;
     mov  bl,[icdir.bColorCount]
     mov  [icdirgr.Colors],bl	     ;
     mov  bx,[icdir.wPlanes]
     mov  [icdirgr.Planes],bx
     mov  bx,[icdir.wBitCount]
     mov  [icdirgr.BitsPerPixel],bx
     mov  ebx,[icdir.dwBytesInRes]
     mov  [icdirgr.ImageSize],ebx    ;  
     mov  [icdirgr.ResourceID],1      ; 


 ;\\\\\\\\\\\\\    
     mov eax,[icdir.dwImageOffset]
     add [ficon],eax

 ;\\\\\\\\\\\ 
     invoke BeginUpdateResource,outBuf,FALSE
     cmp eax,0
     je  error
     mov [hRES],eax
     invoke UpdateResource,[hRES],RT_ICON,1,0,[ficon],[icdir.dwBytesInRes]
     invoke UpdateResource,[hRES],RT_GROUP_ICON,12,0,icdirgr,22
     invoke EndUpdateResource,[hRES],FALSE
 error:
     invoke ExitProcess,0
     ret






section '.data' data readable writeable

     icBuf  db '600.ico',0
     outBuf db 'test.exe',0
     fIconh dd ?
     szIc dd ?
     szIcl dd ?
     ficon dd ?
     cread dd ?
     hRES dd ?


 icdir ICONDIRENTRY
 icdirgr  ICONDIRGROUPICON




section '.idata' import data readable writeable

  library kernel32,'KERNEL32.DLL',\
	   user32,'USER32.DLL'


  include '..\api\kernel32.inc'
  include '..\api\user32.inc'



